
/*
-- les salaires moyens par departement
SELECT D.dname, CAST( avg(E.salary) AS Dec(8,2) ) AS MSALARY
FROM employee E, department D
WHERE E.dno = D.dnumber
GROUP BY D.dname ;
*/

-- le nombre des ayantdroit pour chaque employe
-- ici les employee sans ayantdroit n'apparaissent pas
SELECT  nom, prenom, count(*)
FROM employe JOIN ayantdroit USING(ssn)
GROUP BY ssn, nom, prenom;



-- le nombre des ayantdroit pour chaque employee
-- count(nom_ayant_droit) pour la bonne valeur 0
-- de ceux qui n'ont pas des ayantdroit
SELECT  nom, prenom, count(nom_ayant_droit) AS nombre
FROM employe LEFT JOIN ayantdroit USING(ssn)
GROUP BY ssn, nom, prenom
ORDER BY nombre DESC;



-- le departement avec le salaire moyen le plus eleve
SELECT dnom, CAST( avg(salaire) AS Dec(8,2) ) AS "salaire moy"
FROM employe NATURAL JOIN departement
GROUP BY dnom
ORDER BY 2 DESC
LIMIT 1;


/*

SELECT max(MSALARY)
FROM
    (SELECT D.dname AS DNOM, CAST( avg(E.salary) AS Dec(8,2) ) AS MSALARY
     FROM employee E, department D
     WHERE E.dno = D.dnumber
     GROUP BY D.dname 
     ) AS moyen;
*/
/*
-- nom de projet, le nombre d'employee pour le projet 
-- et le nombre total d'heures
SELECT  P.pname, count(W.hours) AS hours, count(*) AS "NB employes"
FROM project P, works_on W
WHERE W.pno = P.pnumber
GROUP BY P.pnumber, P.pname ;
*/

-- salaire moy des employes ayant l'age >= 50
-- par departement
SELECT avg(salaire),dnom
FROM   employe NATURAL JOIN departement
WHERE  EXTRACT(YEAR FROM CURRENT_DATE) -
       EXTRACT(YEAR FROM date_naiss) >= 50      
GROUP BY dnom
ORDER BY dnom;
/*
HAVING max(salaire) < 50000;
*/

-- l'ecart entre le salaire max et moy par departement
SELECT CAST(max(salaire)-avg(salaire) AS DEC(9,2)) AS Ecart, count(*),
        dnom
FROM employe NATURAL JOIN departement 
WHERE EXTRA
group by dnom, dnumero
ORDER BY Ecart;
  
-- pourcentage du salaire min au salaire max par departement

SELECT dnom, CAST( MIN(salaire)/max(salaire)*100 AS DEC(8,2) ) || '%' AS proportion
FROM employe NATURAL JOIN departement
GROUP BY dnom
ORDER BY proportion;

